"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import typing

import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

# -------- SiLA Basic Types --------
class String(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    value: typing.Text = ...
    def __init__(
        self,
        *,
        value: typing.Text = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["value", b"value"]) -> None: ...

global___String = String

class Integer(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    value: builtins.int = ...
    def __init__(
        self,
        *,
        value: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["value", b"value"]) -> None: ...

global___Integer = Integer

class Real(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    value: builtins.float = ...
    def __init__(
        self,
        *,
        value: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["value", b"value"]) -> None: ...

global___Real = Real

class Boolean(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    value: builtins.bool = ...
    def __init__(
        self,
        *,
        value: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["value", b"value"]) -> None: ...

global___Boolean = Boolean

class Binary(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    BINARYTRANSFERUUID_FIELD_NUMBER: builtins.int
    value: builtins.bytes = ...
    binaryTransferUUID: typing.Text = ...
    def __init__(
        self,
        *,
        value: builtins.bytes = ...,
        binaryTransferUUID: typing.Text = ...,
    ) -> None: ...
    def HasField(
        self,
        field_name: typing_extensions.Literal[
            "binaryTransferUUID", b"binaryTransferUUID", "union", b"union", "value", b"value"
        ],
    ) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "binaryTransferUUID", b"binaryTransferUUID", "union", b"union", "value", b"value"
        ],
    ) -> None: ...
    def WhichOneof(
        self, oneof_group: typing_extensions.Literal["union", b"union"]
    ) -> typing.Optional[typing_extensions.Literal["value", "binaryTransferUUID"]]: ...

global___Binary = Binary

class Date(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    DAY_FIELD_NUMBER: builtins.int
    MONTH_FIELD_NUMBER: builtins.int
    YEAR_FIELD_NUMBER: builtins.int
    TIMEZONE_FIELD_NUMBER: builtins.int
    day: builtins.int = ...
    month: builtins.int = ...
    year: builtins.int = ...
    @property
    def timezone(self) -> global___Timezone: ...
    def __init__(
        self,
        *,
        day: builtins.int = ...,
        month: builtins.int = ...,
        year: builtins.int = ...,
        timezone: typing.Optional[global___Timezone] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["timezone", b"timezone"]) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "day", b"day", "month", b"month", "timezone", b"timezone", "year", b"year"
        ],
    ) -> None: ...

global___Date = Date

class Time(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SECOND_FIELD_NUMBER: builtins.int
    MINUTE_FIELD_NUMBER: builtins.int
    HOUR_FIELD_NUMBER: builtins.int
    TIMEZONE_FIELD_NUMBER: builtins.int
    second: builtins.int = ...
    minute: builtins.int = ...
    hour: builtins.int = ...
    @property
    def timezone(self) -> global___Timezone: ...
    def __init__(
        self,
        *,
        second: builtins.int = ...,
        minute: builtins.int = ...,
        hour: builtins.int = ...,
        timezone: typing.Optional[global___Timezone] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["timezone", b"timezone"]) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "hour", b"hour", "minute", b"minute", "second", b"second", "timezone", b"timezone"
        ],
    ) -> None: ...

global___Time = Time

class Timestamp(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SECOND_FIELD_NUMBER: builtins.int
    MINUTE_FIELD_NUMBER: builtins.int
    HOUR_FIELD_NUMBER: builtins.int
    DAY_FIELD_NUMBER: builtins.int
    MONTH_FIELD_NUMBER: builtins.int
    YEAR_FIELD_NUMBER: builtins.int
    TIMEZONE_FIELD_NUMBER: builtins.int
    second: builtins.int = ...
    minute: builtins.int = ...
    hour: builtins.int = ...
    day: builtins.int = ...
    month: builtins.int = ...
    year: builtins.int = ...
    @property
    def timezone(self) -> global___Timezone: ...
    def __init__(
        self,
        *,
        second: builtins.int = ...,
        minute: builtins.int = ...,
        hour: builtins.int = ...,
        day: builtins.int = ...,
        month: builtins.int = ...,
        year: builtins.int = ...,
        timezone: typing.Optional[global___Timezone] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["timezone", b"timezone"]) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "day",
            b"day",
            "hour",
            b"hour",
            "minute",
            b"minute",
            "month",
            b"month",
            "second",
            b"second",
            "timezone",
            b"timezone",
            "year",
            b"year",
        ],
    ) -> None: ...

global___Timestamp = Timestamp

class Timezone(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    HOURS_FIELD_NUMBER: builtins.int
    MINUTES_FIELD_NUMBER: builtins.int
    hours: builtins.int = ...
    minutes: builtins.int = ...
    def __init__(
        self,
        *,
        hours: builtins.int = ...,
        minutes: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["hours", b"hours", "minutes", b"minutes"]) -> None: ...

global___Timezone = Timezone

# -------- SiLA AnyType Type --------
class Any(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TYPE_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    type: typing.Text = ...
    payload: builtins.bytes = ...
    def __init__(
        self,
        *,
        type: typing.Text = ...,
        payload: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["payload", b"payload", "type", b"type"]) -> None: ...

global___Any = Any

# -------- Framework Types --------
class Duration(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SECONDS_FIELD_NUMBER: builtins.int
    NANOS_FIELD_NUMBER: builtins.int
    seconds: builtins.int = ...
    nanos: builtins.int = ...
    def __init__(
        self,
        *,
        seconds: builtins.int = ...,
        nanos: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["nanos", b"nanos", "seconds", b"seconds"]) -> None: ...

global___Duration = Duration

class CommandExecutionUUID(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALUE_FIELD_NUMBER: builtins.int
    value: typing.Text = ...
    def __init__(
        self,
        *,
        value: typing.Text = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["value", b"value"]) -> None: ...

global___CommandExecutionUUID = CommandExecutionUUID

class CommandConfirmation(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    COMMANDEXECUTIONUUID_FIELD_NUMBER: builtins.int
    LIFETIMEOFEXECUTION_FIELD_NUMBER: builtins.int
    @property
    def commandExecutionUUID(self) -> global___CommandExecutionUUID: ...
    @property
    def lifetimeOfExecution(self) -> global___Duration: ...
    def __init__(
        self,
        *,
        commandExecutionUUID: typing.Optional[global___CommandExecutionUUID] = ...,
        lifetimeOfExecution: typing.Optional[global___Duration] = ...,
    ) -> None: ...
    def HasField(
        self,
        field_name: typing_extensions.Literal[
            "commandExecutionUUID", b"commandExecutionUUID", "lifetimeOfExecution", b"lifetimeOfExecution"
        ],
    ) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "commandExecutionUUID", b"commandExecutionUUID", "lifetimeOfExecution", b"lifetimeOfExecution"
        ],
    ) -> None: ...

global___CommandConfirmation = CommandConfirmation

class ExecutionInfo(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class CommandStatus(_CommandStatus, metaclass=_CommandStatusEnumTypeWrapper):
        pass
    class _CommandStatus:
        V = typing.NewType("V", builtins.int)
    class _CommandStatusEnumTypeWrapper(
        google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_CommandStatus.V], builtins.type
    ):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        waiting = ExecutionInfo.CommandStatus.V(0)
        running = ExecutionInfo.CommandStatus.V(1)
        finishedSuccessfully = ExecutionInfo.CommandStatus.V(2)
        finishedWithError = ExecutionInfo.CommandStatus.V(3)
    waiting = ExecutionInfo.CommandStatus.V(0)
    running = ExecutionInfo.CommandStatus.V(1)
    finishedSuccessfully = ExecutionInfo.CommandStatus.V(2)
    finishedWithError = ExecutionInfo.CommandStatus.V(3)

    COMMANDSTATUS_FIELD_NUMBER: builtins.int
    PROGRESSINFO_FIELD_NUMBER: builtins.int
    ESTIMATEDREMAININGTIME_FIELD_NUMBER: builtins.int
    UPDATEDLIFETIMEOFEXECUTION_FIELD_NUMBER: builtins.int
    commandStatus: global___ExecutionInfo.CommandStatus.V = ...
    @property
    def progressInfo(self) -> global___Real: ...
    @property
    def estimatedRemainingTime(self) -> global___Duration: ...
    @property
    def updatedLifetimeOfExecution(self) -> global___Duration: ...
    def __init__(
        self,
        *,
        commandStatus: global___ExecutionInfo.CommandStatus.V = ...,
        progressInfo: typing.Optional[global___Real] = ...,
        estimatedRemainingTime: typing.Optional[global___Duration] = ...,
        updatedLifetimeOfExecution: typing.Optional[global___Duration] = ...,
    ) -> None: ...
    def HasField(
        self,
        field_name: typing_extensions.Literal[
            "estimatedRemainingTime",
            b"estimatedRemainingTime",
            "progressInfo",
            b"progressInfo",
            "updatedLifetimeOfExecution",
            b"updatedLifetimeOfExecution",
        ],
    ) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "commandStatus",
            b"commandStatus",
            "estimatedRemainingTime",
            b"estimatedRemainingTime",
            "progressInfo",
            b"progressInfo",
            "updatedLifetimeOfExecution",
            b"updatedLifetimeOfExecution",
        ],
    ) -> None: ...

global___ExecutionInfo = ExecutionInfo

# -------- Error Handling --------
class SiLAError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VALIDATIONERROR_FIELD_NUMBER: builtins.int
    DEFINEDEXECUTIONERROR_FIELD_NUMBER: builtins.int
    UNDEFINEDEXECUTIONERROR_FIELD_NUMBER: builtins.int
    FRAMEWORKERROR_FIELD_NUMBER: builtins.int
    @property
    def validationError(self) -> global___ValidationError: ...
    @property
    def definedExecutionError(self) -> global___DefinedExecutionError: ...
    @property
    def undefinedExecutionError(self) -> global___UndefinedExecutionError: ...
    @property
    def frameworkError(self) -> global___FrameworkError: ...
    def __init__(
        self,
        *,
        validationError: typing.Optional[global___ValidationError] = ...,
        definedExecutionError: typing.Optional[global___DefinedExecutionError] = ...,
        undefinedExecutionError: typing.Optional[global___UndefinedExecutionError] = ...,
        frameworkError: typing.Optional[global___FrameworkError] = ...,
    ) -> None: ...
    def HasField(
        self,
        field_name: typing_extensions.Literal[
            "definedExecutionError",
            b"definedExecutionError",
            "error",
            b"error",
            "frameworkError",
            b"frameworkError",
            "undefinedExecutionError",
            b"undefinedExecutionError",
            "validationError",
            b"validationError",
        ],
    ) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "definedExecutionError",
            b"definedExecutionError",
            "error",
            b"error",
            "frameworkError",
            b"frameworkError",
            "undefinedExecutionError",
            b"undefinedExecutionError",
            "validationError",
            b"validationError",
        ],
    ) -> None: ...
    def WhichOneof(
        self, oneof_group: typing_extensions.Literal["error", b"error"]
    ) -> typing.Optional[
        typing_extensions.Literal[
            "validationError", "definedExecutionError", "undefinedExecutionError", "frameworkError"
        ]
    ]: ...

global___SiLAError = SiLAError

class ValidationError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PARAMETER_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    parameter: typing.Text = ...
    message: typing.Text = ...
    def __init__(
        self,
        *,
        parameter: typing.Text = ...,
        message: typing.Text = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["message", b"message", "parameter", b"parameter"]
    ) -> None: ...

global___ValidationError = ValidationError

class DefinedExecutionError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ERRORIDENTIFIER_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    errorIdentifier: typing.Text = ...
    message: typing.Text = ...
    def __init__(
        self,
        *,
        errorIdentifier: typing.Text = ...,
        message: typing.Text = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["errorIdentifier", b"errorIdentifier", "message", b"message"]
    ) -> None: ...

global___DefinedExecutionError = DefinedExecutionError

class UndefinedExecutionError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    MESSAGE_FIELD_NUMBER: builtins.int
    message: typing.Text = ...
    def __init__(
        self,
        *,
        message: typing.Text = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["message", b"message"]) -> None: ...

global___UndefinedExecutionError = UndefinedExecutionError

class FrameworkError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class ErrorType(_ErrorType, metaclass=_ErrorTypeEnumTypeWrapper):
        pass
    class _ErrorType:
        V = typing.NewType("V", builtins.int)
    class _ErrorTypeEnumTypeWrapper(
        google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ErrorType.V], builtins.type
    ):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        COMMAND_EXECUTION_NOT_ACCEPTED = FrameworkError.ErrorType.V(0)
        INVALID_COMMAND_EXECUTION_UUID = FrameworkError.ErrorType.V(1)
        COMMAND_EXECUTION_NOT_FINISHED = FrameworkError.ErrorType.V(2)
        INVALID_METADATA = FrameworkError.ErrorType.V(3)
        NO_METADATA_ALLOWED = FrameworkError.ErrorType.V(4)
    COMMAND_EXECUTION_NOT_ACCEPTED = FrameworkError.ErrorType.V(0)
    INVALID_COMMAND_EXECUTION_UUID = FrameworkError.ErrorType.V(1)
    COMMAND_EXECUTION_NOT_FINISHED = FrameworkError.ErrorType.V(2)
    INVALID_METADATA = FrameworkError.ErrorType.V(3)
    NO_METADATA_ALLOWED = FrameworkError.ErrorType.V(4)

    ERRORTYPE_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    errorType: global___FrameworkError.ErrorType.V = ...
    message: typing.Text = ...
    def __init__(
        self,
        *,
        errorType: global___FrameworkError.ErrorType.V = ...,
        message: typing.Text = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["errorType", b"errorType", "message", b"message"]
    ) -> None: ...

global___FrameworkError = FrameworkError
